Index: /strings_mod.F90
===================================================================
--- /strings_mod.F90	(revision 1)
+++ /strings_mod.F90	(revision 2)
@@ -4,5 +4,5 @@
 
   PRIVATE
-  PUBLIC :: modname, init_printout, msg, fmsg, get_in, lunout, prt_level
+  PUBLIC :: maxlen, init_printout, msg, fmsg, get_in, lunout, prt_level
   PUBLIC :: strLower, strHead, strStack,  strClean,  strIdx,  strCount, strReplace
   PUBLIC :: strUpper, strTail, strStackm, strReduce, strFind, strParse, cat, find
@@ -13,6 +13,6 @@
 
   INTERFACE get_in;     MODULE PROCEDURE getin_s,  getin_i,  getin_r,  getin_l;  END INTERFACE get_in
-  INTERFACE  msg;       MODULE PROCEDURE        msg_1,      msg_l1,       msg_m; END INTERFACE  msg
-  INTERFACE fmsg;       MODULE PROCEDURE       fmsg_1,     fmsg_l1,      fmsg_m; END INTERFACE fmsg
+  INTERFACE  msg;       MODULE PROCEDURE        msg_1,                    msg_m; END INTERFACE  msg
+  INTERFACE fmsg;       MODULE PROCEDURE       fmsg_1,                   fmsg_m; END INTERFACE fmsg
   INTERFACE strHead;    MODULE PROCEDURE    strHead_1,                strHead_m; END INTERFACE strHead
   INTERFACE strTail;    MODULE PROCEDURE    strTail_1,                strTail_m; END INTERFACE strTail
@@ -32,8 +32,7 @@
   INTERFACE testFile;     MODULE PROCEDURE     testFile_1,     testFile_m; END INTERFACE testFile
 
-  CHARACTER(LEN=256), SAVE :: modname = ''                 !--- Current subroutine name
-  INTEGER,            SAVE :: lunout  = 6                  !--- Printing unit  (default: 6, ie. on screen)
-  INTEGER,            SAVE :: prt_level = 1                !--- Printing level (default: 1, ie. print all)
-
+  INTEGER, PARAMETER :: maxlen    = 256                    !--- Standard maximum length for strings
+  INTEGER,      SAVE :: lunout    = 6                      !--- Printing unit  (default: 6, ie. on screen)
+  INTEGER,      SAVE :: prt_level = 1                      !--- Printing level (default: 1, ie. print all)
 
 CONTAINS
@@ -57,5 +56,5 @@
 !==============================================================================================================================
 SUBROUTINE getin_s(nam, val, def)
-USE ioipsl_getin_mod, ONLY: getin
+USE ioipsl_getincom, ONLY: getin
   CHARACTER(LEN=*), INTENT(IN)    :: nam
   CHARACTER(LEN=*), INTENT(INOUT) :: val
@@ -66,5 +65,5 @@
 !==============================================================================================================================
 SUBROUTINE getin_i(nam, val, def)
-USE ioipsl_getin_mod, ONLY: getin
+USE ioipsl_getincom, ONLY: getin
   CHARACTER(LEN=*), INTENT(IN)    :: nam
   INTEGER,          INTENT(INOUT) :: val
@@ -75,5 +74,5 @@
 !==============================================================================================================================
 SUBROUTINE getin_r(nam, val, def)
-USE ioipsl_getin_mod, ONLY: getin
+USE ioipsl_getincom, ONLY: getin
   CHARACTER(LEN=*), INTENT(IN)    :: nam
   REAL,             INTENT(INOUT) :: val
@@ -84,5 +83,5 @@
 !==============================================================================================================================
 SUBROUTINE getin_l(nam, val, def)
-USE ioipsl_getin_mod, ONLY: getin
+USE ioipsl_getincom, ONLY: getin
   CHARACTER(LEN=*), INTENT(IN)    :: nam
   LOGICAL,          INTENT(INOUT) :: val
@@ -97,62 +96,74 @@
 !=== Display one or several messages, one each line, starting with the current routine name "modname".
 !==============================================================================================================================
-SUBROUTINE msg_1(str, unit)
-  CHARACTER(LEN=*),  INTENT(IN) :: str
-  INTEGER, OPTIONAL, INTENT(IN) :: unit
+SUBROUTINE msg_1(str, modname, ll, unit)
+  !--- Display a simple message "str". Optional parameters:
+  !    * "modname": module name, displayed in front of the message (with ": " separator) if present.
+  !    * "ll":      message trigger ; message is displayed only if ll==.TRUE.
+  !    * "unit":    write unit (by default: "lunout")
+  CHARACTER(LEN=*),           INTENT(IN) :: str
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: modname
+  LOGICAL,          OPTIONAL, INTENT(IN) :: ll
+  INTEGER,          OPTIONAL, INTENT(IN) :: unit
   INTEGER :: unt
+  IF(PRESENT(ll)) THEN; IF(ll) RETURN; END IF
   unt = lunout; IF(PRESENT(unit)) unt = unit
-  WRITE(unt,'(a)') TRIM(modname)//': '//str
+  IF(PRESENT(modname)) THEN
+    WRITE(unt,'(a)') TRIM(modname)//': '//str              !--- Routine name provided
+  ELSE
+    WRITE(unt,'(a)') str                                   !--- Simple message
+  END IF
 END SUBROUTINE msg_1
 !==============================================================================================================================
-SUBROUTINE msg_l1(ll, str, unit)
-  LOGICAL,           INTENT(IN) :: ll
-  CHARACTER(LEN=*),  INTENT(IN) :: str
-  INTEGER, OPTIONAL, INTENT(IN) :: unit
-  INTEGER :: unt
-  IF(.NOT.ll) RETURN
-  unt = lunout; IF(PRESENT(unit)) unt = unit
-  WRITE(unt,'(a)') TRIM(modname)//': '//str
-END SUBROUTINE msg_l1
-!==============================================================================================================================
-SUBROUTINE msg_m(str, unit, nmax)
-  CHARACTER(LEN=*),  INTENT(IN) :: str(:)
-  INTEGER, OPTIONAL, INTENT(IN) :: unit
-  INTEGER, OPTIONAL, INTENT(IN) :: nmax
-  CHARACTER(LEN=256), ALLOCATABLE :: s(:)
+SUBROUTINE msg_m(str, modname, ll, unit, nmax)
+  !--- Same as msg_1 with multiple strings that are stacked (separator: coma) on up to "nmax" full lines.
+  CHARACTER(LEN=*),           INTENT(IN) :: str(:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: modname
+  LOGICAL,          OPTIONAL, INTENT(IN) :: ll
+  INTEGER,          OPTIONAL, INTENT(IN) :: unit
+  INTEGER,          OPTIONAL, INTENT(IN) :: nmax
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: s(:)
   INTEGER :: unt, nmx, k
+  LOGICAL :: lerr
+  lerr = .TRUE.; IF(PRESENT(ll))  lerr = ll
   unt = lunout ; IF(PRESENT(unit)) unt = unit
   nmx = 128;     IF(PRESENT(nmax)) nmx = nmax
   s = strStackm(str, ', ', nmx)
-  DO k=1,SIZE(s); WRITE(unt,'(a)') TRIM(modname)//': '//TRIM(s(k)); END DO
+  IF(PRESENT(modname)) THEN
+    DO k=1,SIZE(s); CALL msg_1(s(k), modname, lerr, unt); END DO
+  ELSE
+    DO k=1,SIZE(s); CALL msg_1(s(k), ll=lerr, unit=unt);  END DO
+  END IF
 END SUBROUTINE msg_m
 !==============================================================================================================================
-LOGICAL FUNCTION fmsg_1(str, unit) RESULT(lerr)
-  CHARACTER(LEN=*),  INTENT(IN)  :: str
-  INTEGER, OPTIONAL, INTENT(IN)  :: unit
+LOGICAL FUNCTION fmsg_1(str, modname, ll, unit) RESULT(lerr)
+  CHARACTER(LEN=*),           INTENT(IN) :: str
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: modname
+  LOGICAL,          OPTIONAL, INTENT(IN) :: ll
+  INTEGER,          OPTIONAL, INTENT(IN) :: unit
   INTEGER :: unt
-  lerr = .TRUE.
+  lerr = .TRUE.; IF(PRESENT(ll))  lerr = ll
   unt = lunout ; IF(PRESENT(unit)) unt = unit
-  CALL msg_1(str, unt)
+  IF(PRESENT(modname)) THEN
+    CALL msg_1(str, modname, lerr, unt)
+  ELSE
+    CALL msg_1(str, ll=lerr, unit=unt)
+  END IF
 END FUNCTION fmsg_1
 !==============================================================================================================================
-LOGICAL FUNCTION fmsg_l1(li, str, unit) RESULT(lerr)
-  LOGICAL,           INTENT(IN)  :: li
-  CHARACTER(LEN=*),  INTENT(IN)  :: str
-  INTEGER, OPTIONAL, INTENT(IN)  :: unit
-  INTEGER :: unt
-  lerr = li;     IF(.NOT.lerr) RETURN
-  unt = lunout ; IF(PRESENT(unit)) unt = unit
-  CALL msg_l1(lerr, str, unt)
-END FUNCTION fmsg_l1
-!==============================================================================================================================
-LOGICAL FUNCTION fmsg_m(str, unit, nmax) RESULT(lerr)
-  CHARACTER(LEN=*),  INTENT(IN)  :: str(:)
-  INTEGER, OPTIONAL, INTENT(IN)  :: unit
-  INTEGER, OPTIONAL, INTENT(IN)  :: nmax
+LOGICAL FUNCTION fmsg_m(str, modname, ll, unit, nmax) RESULT(lerr)
+  CHARACTER(LEN=*),           INTENT(IN)  :: str(:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: modname
+  LOGICAL,          OPTIONAL, INTENT(IN) :: ll
+  INTEGER,          OPTIONAL, INTENT(IN) :: unit
+  INTEGER,          OPTIONAL, INTENT(IN)  :: nmax
   INTEGER :: unt, nmx
-  lerr = .TRUE.
+  lerr = .TRUE.; IF(PRESENT(ll))  lerr = ll
   unt = lunout ; IF(PRESENT(unit)) unt = unit
   nmx = 128;     IF(PRESENT(nmax)) nmx = nmax
-  CALL msg_m(str, unt, nmx)
+  IF(PRESENT(modname)) THEN
+    CALL msg_m(str, modname, lerr, unt, nmx)
+  ELSE
+    CALL msg_m(str, ll=lerr, unit=unt, nmax=nmx)
+  END IF
 END FUNCTION fmsg_m
 !==============================================================================================================================
@@ -162,5 +173,5 @@
 !=== Lower/upper case conversion function. ====================================================================================
 !==============================================================================================================================
-ELEMENTAL CHARACTER(LEN=256) FUNCTION strLower(str) RESULT(out)
+ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION strLower(str) RESULT(out)
   CHARACTER(LEN=*), INTENT(IN) :: str
   INTEGER :: k
@@ -171,5 +182,5 @@
 END FUNCTION strLower
 !==============================================================================================================================
-ELEMENTAL CHARACTER(LEN=256) FUNCTION strUpper(str) RESULT(out)
+ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION strUpper(str) RESULT(out)
   CHARACTER(LEN=*), INTENT(IN) :: str
   INTEGER :: k
@@ -188,5 +199,5 @@
 !===    * strHead(..,.TRUE.)  = 'a_b'         ${str%$sep*}                                                     ================
 !==============================================================================================================================
-CHARACTER(LEN=256) FUNCTION strHead_1(str,sep,lFirst) RESULT(out)
+CHARACTER(LEN=maxlen) FUNCTION strHead_1(str,sep,lFirst) RESULT(out)
   CHARACTER(LEN=*),           INTENT(IN) :: str
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: sep
@@ -203,5 +214,5 @@
 !==============================================================================================================================
 FUNCTION strHead_m(str,sep,lFirst) RESULT(out)
-  CHARACTER(LEN=256),        ALLOCATABLE :: out(:)
+  CHARACTER(LEN=maxlen),     ALLOCATABLE :: out(:)
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: sep
@@ -222,5 +233,5 @@
 !===    * strHead(..,.TRUE.)  = 'c'           ${str##*$sep}                                                    ================
 !==============================================================================================================================
-CHARACTER(LEN=256) FUNCTION strTail_1(str,sep,lFirst) RESULT(out)
+CHARACTER(LEN=maxlen) FUNCTION strTail_1(str,sep,lFirst) RESULT(out)
   CHARACTER(LEN=*),           INTENT(IN) :: str
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: sep
@@ -237,5 +248,5 @@
 !==============================================================================================================================
 FUNCTION strTail_m(str,sep,lFirst) RESULT(out)
-  CHARACTER(LEN=256),        ALLOCATABLE :: out(:)
+  CHARACTER(LEN=maxlen),     ALLOCATABLE :: out(:)
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: sep
@@ -270,10 +281,10 @@
 !==============================================================================================================================
 FUNCTION strStackm(str, sep, nmax) RESULT(out)
-  CHARACTER(LEN=256),        ALLOCATABLE :: out(:)
+  CHARACTER(LEN=maxlen),     ALLOCATABLE :: out(:)
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: sep
   INTEGER,          OPTIONAL, INTENT(IN) :: nmax
-  CHARACTER(LEN=256), ALLOCATABLE :: t(:)
-  CHARACTER(LEN=256) :: sp
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: t(:)
+  CHARACTER(LEN=maxlen) :: sp
   INTEGER :: is, ns, no, mx, n
   IF(SIZE(str) == 0) THEN; out = ['']; RETURN; END IF
@@ -328,5 +339,5 @@
   CHARACTER(LEN=*), ALLOCATABLE, INTENT(INOUT) :: str1(:)
   INTEGER,          OPTIONAL,    INTENT(OUT)   :: nb
-  CHARACTER(LEN=256), ALLOCATABLE :: s1(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: s1(:)
   INTEGER :: k, n, n1
   IF(PRESENT(nb)) nb = 0
@@ -342,5 +353,5 @@
   CHARACTER(LEN=*),   ALLOCATABLE, INTENT(INOUT) :: str1(:)
   CHARACTER(LEN=*),                INTENT(IN)    :: str2(:)
-  CHARACTER(LEN=256), ALLOCATABLE :: s1(:), s2(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: s1(:), s2(:)
   INTEGER :: k
   IF(SIZE(str2)==0) RETURN
@@ -432,8 +443,8 @@
   LOGICAL, OPTIONAL, INTENT(IN)  :: lSc                              !--- Care about nbs with front sign or in scient. notation
 
-  INTEGER              :: idx0                                       !--- Used to display an identified non-numeric string
-  INTEGER, ALLOCATABLE :: ii(:)
-  LOGICAL              :: ll, ls
-  CHARACTER(LEN=256)   :: d
+  INTEGER               :: idx0                                      !--- Used to display an identified non-numeric string
+  INTEGER, ALLOCATABLE  :: ii(:)
+  LOGICAL               :: ll, ls
+  CHARACTER(LEN=maxlen) :: d
 !  modname = 'strIdx'
   lerr = .FALSE.
@@ -545,5 +556,5 @@
   DO
     lerr = strIdx_prv(r, delimiter, ib, ie, jd, ll)
-    IF(fmsg(lerr,'"'//TRIM(r(ib:ie-1))//'" is not numeric')) RETURN
+    IF(fmsg('"'//TRIM(r(ib:ie-1))//'" is not numeric', ll=lerr)) RETURN
     IF(jd == 0) EXIT
     ib = ie + LEN(delimiter(jd))
@@ -560,9 +571,9 @@
 !==============================================================================================================================
 LOGICAL FUNCTION strParse_1(rawList, delimiter, keys, lSc, vals, n) RESULT(lerr)
-  CHARACTER(LEN=*),                          INTENT(IN)  :: rawList, delimiter
-  CHARACTER(LEN=256), ALLOCATABLE,           INTENT(OUT) :: keys(:)
-  LOGICAL,                         OPTIONAL, INTENT(IN)  :: lSc      !--- Take care about numbers in scientific notation
-  CHARACTER(LEN=256), ALLOCATABLE, OPTIONAL, INTENT(OUT) :: vals(:)
-  INTEGER,                         OPTIONAL, INTENT(OUT) :: n
+  CHARACTER(LEN=*),                             INTENT(IN)  :: rawList, delimiter
+  CHARACTER(LEN=maxlen), ALLOCATABLE,           INTENT(OUT) :: keys(:)
+  LOGICAL,                            OPTIONAL, INTENT(IN)  :: lSc      !--- Take care about numbers in scientific notation
+  CHARACTER(LEN=maxlen), ALLOCATABLE, OPTIONAL, INTENT(OUT) :: vals(:)
+  INTEGER,                            OPTIONAL, INTENT(OUT) :: n
   LOGICAL :: ll
 !  modname = 'strParse'
@@ -574,10 +585,10 @@
 !==============================================================================================================================
 LOGICAL FUNCTION strParse_m(rawList, delimiter, keys, lSc, vals, n, id) RESULT(lerr)
-  CHARACTER(LEN=*),                          INTENT(IN)  :: rawList, delimiter(:)
-  CHARACTER(LEN=256),           ALLOCATABLE, INTENT(OUT) :: keys(:)  !--- Parsed keys vector
-  LOGICAL,            OPTIONAL,              INTENT(IN)  :: lSc      !--- Take care about numbers in scientific notation
-  CHARACTER(LEN=256), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: vals(:)  !--- Values for <name>=<value> keys
-  INTEGER,            OPTIONAL,              INTENT(OUT) :: n        !--- Length of the parsed vector
-  INTEGER,            OPTIONAL, ALLOCATABLE, INTENT(OUT) :: id(:)    !--- Indexes of the separators in "delimiter(:)" vector
+  CHARACTER(LEN=*),                             INTENT(IN)  :: rawList, delimiter(:)
+  CHARACTER(LEN=maxlen),           ALLOCATABLE, INTENT(OUT) :: keys(:)  !--- Parsed keys vector
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lSc      !--- Take care about numbers in scientific notation
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: vals(:)  !--- Values for <name>=<value> keys
+  INTEGER,               OPTIONAL,              INTENT(OUT) :: n        !--- Length of the parsed vector
+  INTEGER,               OPTIONAL, ALLOCATABLE, INTENT(OUT) :: id(:)    !--- Indexes of the separators in "delimiter(:)" vector
 
   CHARACTER(LEN=1024) :: r
@@ -587,5 +598,5 @@
 !  modname = 'strParse'
   ll = .FALSE.; IF(PRESENT(lSc)) ll = lSc
-  IF(test(fmsg(strCount_1m(rawList, delimiter, nk, ll), "Couldn't parse list: non-numerical strings were found"),lerr)) RETURN
+  IF(test(fmsg("Couldn't parse list: non-numerical strings were found", ll=strCount_1m(rawList, delimiter, nk, ll)),lerr)) RETURN
 
   !--- FEW ALLOCATIONS
@@ -600,5 +611,5 @@
   ib = 1
   DO ik = 1, nk-1
-    IF(test(fmsg(strIdx_prv(r, delimiter, ib, ie, jd, ll),'Non-numeric values found'),lerr)) RETURN
+    IF(test(fmsg('Non-numeric values found', ll=strIdx_prv(r, delimiter, ib, ie, jd, ll)),lerr)) RETURN
     keys(ik) = r(ib:ie-1)
     IF(PRESENT(vals)) CALL parseKeys(keys(ik), vals(ik))             !--- Parse a <key>=<val> pair
@@ -674,6 +685,6 @@
   CHARACTER(LEN=*),           TARGET, INTENT(IN) :: s0
   CHARACTER(LEN=*), OPTIONAL, TARGET, INTENT(IN) :: s1, s2, s3, s4, s5, s6, s7, s8, s9
-  CHARACTER(LEN=256), ALLOCATABLE :: out(:)
-  CHARACTER(LEN=256), POINTER     :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: out(:)
+  CHARACTER(LEN=maxlen), POINTER     :: s
   LOGICAL :: lv(10)
   INTEGER :: iv
@@ -693,6 +704,6 @@
   CHARACTER(LEN=*),           TARGET, DIMENSION(:), INTENT(IN) :: s0
   CHARACTER(LEN=*), OPTIONAL, TARGET, DIMENSION(:), INTENT(IN) :: s1, s2, s3, s4, s5, s6, s7, s8, s9
-  CHARACTER(LEN=256), ALLOCATABLE :: out(:,:)
-  CHARACTER(LEN=256), POINTER     :: s(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: out(:,:)
+  CHARACTER(LEN=maxlen), POINTER     :: s(:)
   LOGICAL :: lv(10)
   INTEGER :: nrow, ncol, iv, n
@@ -707,5 +718,5 @@
     END SELECT
     n = SIZE(s, DIM=1)
-    IF(n/=nrow) THEN; CALL msg('Can''t concatenate vectors of differing lengths',1); STOP; END IF
+    IF(n/=nrow) THEN; CALL msg("Can't concatenate vectors of differing lengths"); STOP; END IF
     out(:,iv) = s(:)
   END DO
@@ -748,5 +759,5 @@
     END SELECT
     n = SIZE(i, DIM=1)
-    IF(n/=nrow) THEN; CALL msg('Can''t concatenate vectors of differing lengths',1); STOP; END IF
+    IF(n/=nrow) THEN; CALL msg("Can't concatenate vectors of differing lengths"); STOP; END IF
     out(:,iv) = i(:)
   END DO
@@ -789,5 +800,5 @@
     END SELECT
     n = SIZE(r, DIM=1)
-    IF(n/=nrow) THEN; CALL msg('Can''t concatenate vectors of differing lengths',1); STOP; END IF
+    IF(n/=nrow) THEN; CALL msg("Can't concatenate vectors of differing lengths"); STOP; END IF
     out(:,iv) = r(:)
   END DO
@@ -830,5 +841,5 @@
     END SELECT
     n = SIZE(d, DIM=1)
-    IF(n/=nrow) THEN; CALL msg('Can''t concatenate vectors of differing lengths',1); STOP; END IF
+    IF(n/=nrow) THEN; CALL msg("Can't concatenate vectors of differing lengths"); STOP; END IF
     out(:,iv) = d(:)
   END DO
@@ -852,6 +863,6 @@
 
   CHARACTER(LEN=2048) :: row
-  CHARACTER(LEN=256)  :: rFm, el
-  CHARACTER(LEN=256), ALLOCATABLE :: d(:,:)
+  CHARACTER(LEN=maxlen)  :: rFm, el
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: d(:,:)
   CHARACTER(LEN=1) :: s1, sp
   INTEGER :: is, ii, ir, np, nrow, unt, ic
@@ -870,5 +881,5 @@
 
   !--- CHECK ARGUMENTS COHERENCE
-  lerr = np /= SIZE(titles); IF(fmsg(lerr, 'string "pattern" length and titles list mismatch')) RETURN
+  lerr = np /= SIZE(titles); IF(fmsg('string "pattern" length and titles list mismatch', ll=lerr)) RETURN
   IF(ls) THEN; ns = SIZE(s, DIM=1); ncol = ncol + SIZE(s, DIM=2)
     lerr = COUNT([(p(ic:ic)=='s', ic=1, np)]) /= SIZE(s, DIM=2)
@@ -880,10 +891,9 @@
     lerr = COUNT([(p(ic:ic)=='r', ic=1, np)]) /= SIZE(r, DIM=2)
   END IF
-
-  IF(fmsg(lerr, 'string "pattern" length and arguments number mismatch')) RETURN
-  lerr = ncol /= SIZE(titles); IF(fmsg(lerr, '"titles" length and arguments number mismatch')) RETURN
-  lerr = ls.AND.li.AND.ns/=ni; IF(fmsg(lerr, 'string and integer arguments lengths mismatch')) RETURN
-  lerr = ls.AND.lr.AND.ns/=nr; IF(fmsg(lerr,    'string and real arguments lengths mismatch')) RETURN
-  lerr = li.AND.lr.AND.ni/=nr; IF(fmsg(lerr,   'integer and real arguments lengths mismatch')) RETURN
+  IF(fmsg('string "pattern" length and arguments number mismatch', ll=lerr)) RETURN
+  lerr = ncol /= SIZE(titles); IF(fmsg('"titles" length and arguments number mismatch', ll=lerr)) RETURN
+  lerr = ls.AND.li.AND.ns/=ni; IF(fmsg('string and integer arguments lengths mismatch', ll=lerr)) RETURN
+  lerr = ls.AND.lr.AND.ns/=nr; IF(fmsg(   'string and real arguments lengths mismatch', ll=lerr)) RETURN
+  lerr = li.AND.lr.AND.ni/=nr; IF(fmsg(  'integer and real arguments lengths mismatch', ll=lerr)) RETURN
   nrow = MAX(ns,ni,nr)+1
   nmx = nrow; IF(PRESENT(nmax)) nmx = MIN(nmx,nmax+1)
@@ -912,8 +922,8 @@
     END DO
     nr = LEN_TRIM(row)-1                                             !--- Final separator removed
-    CALL msg(row(1:nr), unt)
+    CALL msg(row(1:nr), unit=unt)
     IF(ir /= 1) CYCLE                                                !--- Titles are underlined
     row=''; DO ic=1,ncol; row=TRIM(row)//REPEAT('-',n(ic))//'+'; END DO
-    CALL msg(row(1:LEN_TRIM(row)-1), unt)
+    CALL msg(row(1:LEN_TRIM(row)-1), unit=unt)
   END DO
 
@@ -932,7 +942,7 @@
   LOGICAL,          OPTIONAL, INTENT(IN)  :: llast         !--- Last variable: no final ','
 
-  CHARACTER(LEN=256)  :: rFm, el
-  CHARACTER(LEN=256), ALLOCATABLE :: d(:,:)
-  CHARACTER(LEN=:),   ALLOCATABLE :: sp, row
+  CHARACTER(LEN=maxlen)  :: rFm, el
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: d(:,:)
+  CHARACTER(LEN=:),      ALLOCATABLE :: sp, row
   INTEGER :: is, ii, ir, nrow, ic
   INTEGER :: ns, ni, nr, ncol, np
@@ -957,9 +967,9 @@
     lerr = COUNT([(p(ic:ic)=='r', ic=1, np)]) /= SIZE(r, DIM=2)
   END IF
-  IF(fmsg(lerr, 'string "pattern" length and arguments number mismatch')) RETURN
-  lerr = ncol /= SIZE(titles); IF(fmsg(lerr, '"titles" length and arguments number mismatch')) RETURN
-  lerr = ls.AND.li.AND.ns/=ni; IF(fmsg(lerr, 'string and integer arguments lengths mismatch')) RETURN
-  lerr = ls.AND.lr.AND.ns/=nr; IF(fmsg(lerr,    'string and real arguments lengths mismatch')) RETURN
-  lerr = li.AND.lr.AND.ni/=nr; IF(fmsg(lerr,   'integer and real arguments lengths mismatch')) RETURN
+  IF(fmsg('string "pattern" length and arguments number mismatch', ll=lerr)) RETURN
+  lerr = ncol /= SIZE(titles); IF(fmsg('"titles" length and arguments number mismatch', ll=lerr)) RETURN
+  lerr = ls.AND.li.AND.ns/=ni; IF(fmsg('string and integer arguments lengths mismatch', ll=lerr)) RETURN
+  lerr = ls.AND.lr.AND.ns/=nr; IF(fmsg(   'string and real arguments lengths mismatch', ll=lerr)) RETURN
+  lerr = li.AND.lr.AND.ni/=nr; IF(fmsg(  'integer and real arguments lengths mismatch', ll=lerr)) RETURN
 
   !--- Allocate the assembled quantities array
@@ -1012,10 +1022,10 @@
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN)  :: err_msg, nam(:), subn   !--- Error message, variables and calling subroutine names
   INTEGER,          OPTIONAL, INTENT(IN)  :: nmax, unit              !--- Maximum number of lines to display (default: all)
-  CHARACTER(LEN=256),         ALLOCATABLE :: ttl(:)
+  CHARACTER(LEN=maxlen),      ALLOCATABLE :: ttl(:)
   LOGICAL,                    ALLOCATABLE :: m(:)
   INTEGER,                    ALLOCATABLE :: ki(:), kj(:)
   INTEGER                                 :: i, j, k, rk, rk1, ib, ie, itr, nm, unt, nmx, nv
-  CHARACTER(LEN=256)                      :: mes, sub, fm='(f12.9)', v, s
-  CHARACTER(LEN=256),         ALLOCATABLE :: vnm(:)
+  CHARACTER(LEN=maxlen)                   :: mes, sub, fm='(f12.9)', v, s
+  CHARACTER(LEN=maxlen),      ALLOCATABLE :: vnm(:)
 
   lerr = ANY(ll); IF(.NOT.lerr) RETURN                               !--- No outliers -> finished
@@ -1028,9 +1038,8 @@
 
   rk = SIZE(n); nv = SIZE(vnm)
-  IF(test(fmsg(nv /= 1 .AND. nv /= n(rk), 'In "'//TRIM(sub)//'": SIZE(nam) /= 1 or =last "n" element'    , unt),lerr)) RETURN
-  IF(test(fmsg(SIZE(a) /= SIZE(ll),       'In "'//TRIM(sub)//'": "ll" and "a" sizes mismatch'            , unt),lerr)) RETURN
-  IF(test(fmsg(SIZE(a) /= PRODUCT(n),     'In "'//TRIM(sub)//'": profile "n" does not match "a" and "ll"', unt),lerr)) RETURN
-
-  WRITE(unt,*)'Outliers detected by '//TRIM(sub)//': '//TRIM(mes)
+  IF(test(fmsg('SIZE(nam) /= 1 and /= last "n" element', sub, nv /= 1 .AND. nv /= n(rk), unt),lerr)) RETURN
+  IF(test(fmsg('ll" and "a" sizes mismatch',             sub, SIZE(a) /= SIZE(ll),       unt),lerr)) RETURN
+  IF(test(fmsg('profile "n" does not match "a" and "ll', sub, SIZE(a) /= PRODUCT(n),     unt),lerr)) RETURN
+  CALL msg(mes, sub, unit=unt)
 
   !--- SCALAR CASE: single value to display
@@ -1051,5 +1060,5 @@
     IF(nv == 1) lerr = dispTable('sr', ttl,               s=cat(PACK(nam,ll)), r=cat(PACK(a,ll)), rFmt=fm, nmax=nmax)
     IF(nv /= 1) lerr = dispTable('ir', ['name ','value'], i=cat(PACK(ki,m)),   r=cat(PACK(a,ll)), rFmt=fm, nmax=nmax)
-    CALL msg(lerr,'In '//TRIM(sub)//": can't display outliers table", unt)
+    CALL msg("can't display outliers table", sub, lerr, unt)
     RETURN
   END IF
@@ -1068,6 +1077,6 @@
     IF(rk==2) lerr = dispTable('ir',  ttl, i=cat(PACK(ki,m)),            r=cat(PACK(a(ib:ie),m)), rFmt=fm, nmax=nmax)
     IF(rk==3) lerr = dispTable('iir', ttl, i=cat(PACK(ki,m),PACK(kj,m)), r=cat(PACK(a(ib:ie),m)), rFmt=fm, nmax=nmax)
-    CALL msg(lerr,'In '//TRIM(sub)//": can't display outliers table", unt)
-    IF(lerr) THEN; CALL msg("Can't display outliers table"); RETURN; END IF
+    CALL msg("can't display outliers table", sub, lerr, unt)
+    IF(lerr) RETURN
   END DO
 END FUNCTION dispOutliers_1
@@ -1082,6 +1091,6 @@
   INTEGER,          OPTIONAL, INTENT(IN)  :: nmax, unit              !--- Maximum number of lines to display (default: all)
 
-  CHARACTER(LEN=256)                      :: mes, sub, fm='(f12.9)', prf
-  CHARACTER(LEN=256),         ALLOCATABLE :: ttl(:), vnm(:)
+  CHARACTER(LEN=maxlen)                   :: mes, sub, fm='(f12.9)', prf
+  CHARACTER(LEN=maxlen),      ALLOCATABLE :: ttl(:), vnm(:)
   LOGICAL,                    ALLOCATABLE :: m(:)
   INTEGER,                    ALLOCATABLE :: ki(:), kj(:), kl(:)
@@ -1096,7 +1105,7 @@
   nmx = SIZE(a);                  IF(PRESENT(nmax))    nmx = MIN(nmx,nmax)!--- Maximum number of lines to print
   unt = lunout;                   IF(PRESENT(unit))    unt = unit         !--- Unit to print messages
-  lerr = SIZE(vnm) /= nv;         IF(fmsg(lerr, 'In "dispOutlayers_2": SIZE(nam) /= SIZE(a,2)'  ,unt)) RETURN
-  lerr = SIZE(a,1) /= SIZE(ll);   IF(fmsg(lerr,'In '//TRIM(sub)//': "ll" and "a" sizes mismatch',unt)) RETURN
-  lerr = SIZE(a,1) /= PRODUCT(n); IF(fmsg(lerr,'In '//TRIM(sub)//': profile "n" does not match "a" and "ll"',unt)) RETURN
+  lerr = SIZE(vnm) /= nv;         IF(fmsg('SIZE(nam) /= SIZE(a,2)',                  sub, lerr, unt)) RETURN
+  lerr = SIZE(a,1) /= SIZE(ll);   IF(fmsg('"ll" and "a" sizes mismatch',             sub, lerr, unt)) RETURN
+  lerr = SIZE(a,1) /= PRODUCT(n); IF(fmsg('profile "n" does not match "a" and "ll"', sub, lerr, unt)) RETURN
 
   SELECT CASE(rk1)                                                   !--- Indices list
@@ -1116,5 +1125,5 @@
   IF(rk == 3) lerr = dispTable(prf, ttl, i = cat(PACK(ki,ll),PACK(kj,ll),PACK(kl,ll)), &
                      r = val, rFmt=fm, nmax=nmax)
-  CALL msg(lerr,'In '//TRIM(sub)//": can't display outliers table", unt)
+  CALL msg("can't display outliers table", sub, lerr, unt)
 END FUNCTION dispOutliers_2
 !==============================================================================================================================
@@ -1125,9 +1134,9 @@
 !==============================================================================================================================
 LOGICAL FUNCTION reduceExpr_1(str, val) RESULT(lerr)
-  CHARACTER(LEN=*),    INTENT(IN)  :: str
-  CHARACTER(LEN=256),  INTENT(OUT) :: val
-
-  CHARACTER(LEN=256)               :: v
-  CHARACTER(LEN=1024)              :: s, vv
+  CHARACTER(LEN=*),      INTENT(IN)  :: str
+  CHARACTER(LEN=maxlen), INTENT(OUT) :: val
+
+  CHARACTER(LEN=maxlen)              :: v
+  CHARACTER(LEN=1024)                :: s, vv
   CHARACTER(LEN=1024), ALLOCATABLE :: vl(:)
   INTEGER,             ALLOCATABLE :: ip(:)
@@ -1141,5 +1150,5 @@
   ll = strCount(s,')',nn)
   lerr = nl /= nn
-  IF(fmsg(lerr, 'Mismatching number of opening and closing parenthesis: '//TRIM(s))) RETURN
+  IF(fmsg('Mismatching number of opening and closing parenthesis: '//TRIM(s), ll=lerr)) RETURN
   nl = 2*nl-1
 
@@ -1175,10 +1184,10 @@
 !==============================================================================================================================
 LOGICAL FUNCTION reduceExpr_basic(str, val) RESULT(lerr)
-  CHARACTER(LEN=*),   INTENT(IN)  :: str
-  CHARACTER(LEN=*),   INTENT(OUT) :: val
-  DOUBLE PRECISION,   ALLOCATABLE :: vl(:)
-  INTEGER,            ALLOCATABLE :: id(:)
-  CHARACTER(LEN=256), ALLOCATABLE :: ky(:)
-  CHARACTER(LEN=1),   ALLOCATABLE :: op(:)
+  CHARACTER(LEN=*),      INTENT(IN)  :: str
+  CHARACTER(LEN=*),      INTENT(OUT) :: val
+  DOUBLE PRECISION,      ALLOCATABLE :: vl(:)
+  INTEGER,               ALLOCATABLE :: id(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: ky(:)
+  CHARACTER(LEN=1),      ALLOCATABLE :: op(:)
 
   CHARACTER(LEN=1024) :: s
@@ -1194,5 +1203,5 @@
   vl = str2dble(ky)                                                            !--- Conversion to doubles
   lerr = ANY(vl >= HUGE(1.d0))
-  IF(fmsg(lerr,'Some values are non-numeric in: '//TRIM(s))) RETURN            !--- Non-numerical values found
+  IF(fmsg('Some values are non-numeric in: '//TRIM(s), ll=lerr)) RETURN        !--- Non-numerical values found
   DO io = 1, SIZE(op)                                                          !--- Loop on known operators (order matters !)
     DO i = SIZE(id), 1, -1                                                     !--- Loop on found operators
@@ -1218,7 +1227,7 @@
 !==============================================================================================================================
 FUNCTION reduceExpr_m(str, val) RESULT(lerr)
-  LOGICAL,            ALLOCATABLE              :: lerr(:)
-  CHARACTER(LEN=*),                INTENT(IN)  :: str(:)
-  CHARACTER(LEN=256), ALLOCATABLE, INTENT(OUT) :: val(:)
+  LOGICAL,               ALLOCATABLE              :: lerr(:)
+  CHARACTER(LEN=*),                   INTENT(IN)  :: str(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: val(:)
   INTEGER :: i
   ALLOCATE(lerr(SIZE(str)),val(SIZE(str)))
@@ -1277,5 +1286,5 @@
 END FUNCTION str2dble
 !==============================================================================================================================
-ELEMENTAL CHARACTER(LEN=256) FUNCTION bool2str(b) RESULT(out)
+ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION bool2str(b) RESULT(out)
   LOGICAL, INTENT(IN) :: b
   WRITE(out,*)b
@@ -1283,5 +1292,5 @@
 END FUNCTION bool2str
 !==============================================================================================================================
-ELEMENTAL CHARACTER(LEN=256) FUNCTION int2str(i, nDigits) RESULT(out)
+ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION int2str(i, nDigits) RESULT(out)
   INTEGER,           INTENT(IN) :: i
   INTEGER, OPTIONAL, INTENT(IN) :: nDigits
@@ -1292,5 +1301,5 @@
 END FUNCTION int2str
 !==============================================================================================================================
-ELEMENTAL CHARACTER(LEN=256) FUNCTION real2str(r,fmt) RESULT(out)
+ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION real2str(r,fmt) RESULT(out)
   REAL,                       INTENT(IN) :: r
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fmt
